#include <stdio.h>
#include <stdlib.h>
#include "omp.h"

#define NUM_STEPS 1000000

int main( void )
{
    double sum = 0.0, pi;
    double step = 1.0/NUM_STEPS;
    double x_i;
    int i;

    double t0, t1;
    t0 = omp_get_wtime();
    for ( i = 0; i < NUM_STEPS; i++ )
    {
        x_i = (i + 0.5) * step;
        sum += 4.0 / (1.0 + x_i * x_i);
    }
    pi = sum * step;
    t1 = omp_get_wtime();

    printf("Pi: %.10e - took %f seconds\n", pi, t1-t0);

    return 0;
}
